//DEFINE SENSORS
#define TOUCH  			SENSOR_1
#define COLOR  			SENSOR_2
#define COLOR_VALUE    		IN_2
#define SONAR_REAR     		SENSOR_4
#define SONAR_REAR_VALUE  	IN_4
#define SONAR_FRONT       	SENSOR_3
#define SONAR_FRONT_VALUE 	IN_3

//DEFINE threshold
#define RNEAR_THRESHOLD  	20 //5 //20 //35
#define FNEAR_THRESHOLD  	35 //5 //35 //50

#define RPREDATOR_THRESHOLD	100 //150//50 //15 //75 //50
#define FPREDATOR_THRESHOLD	80 //150 //75 //15 //100 //75

//Tempo
#define TIMEOUT                 60000 
#define SYNCTIME                200
#define TEXTOUT                 1000

//Colori
#define BLACK                   1
#define BLUE                    2
#define GREEN                   3
#define YELLOW                  4
#define RED                     5
#define WHITE                   6
#define LIGHTBLACK              35

//Movimento
#define PPOWER		  	60	//75
#define MAXPOWER          	100
#define MTIME             	100
#define MCYCLE            	30
#define ROTATE45          	500
#define ROTATE90          	600
#define ROTATE135         	1300
#define ROTATE180         	1500
#define MPOWER		      	50
#define RIGHT		      	0
#define LEFT		      	1

//Segni
#define ROCK              	1
#define PAPER             	2
#define SCISSORS          	3
#define LIZARD            	4
#define SPOCK             	5

//Morra
#define ROBOTWIN	  	1
#define PLAYERWIN	      	2		
#define DRAW		      	3

//Connessioni BLuetooth
#define BT_CONN0          	0
#define BT_CONN		      	1
#define BT_CONN2	      	2

//Comandi Joystick
#define FORWARD           	1
#define BACKWARD          	2
#define TURNRIGHT         	3
#define TURNLEFT          	4
#define ROTATERIGHT       	5
#define ROTATELEFT        	6
#define BREAKALL          	7
#define ATTACK            	8
#define OPENPINSIR	        9

//Joystick
#define MINAXIS	          	30
#define MAXAXIS	          	70

//Modalità
#define QUICKMATCH        	1
#define SURVIVAL          	2
#define EXIT          	        4

//Esito partita
#define GAMEOVER          	1
#define NEXTROUND         	2
#define SCORE_THRESHOLD	        2

//Scelta del giocatore
int PlayerChoice(){
	ClearScreen();
	int choice = ROCK;
	while(true){
		Wait(SYNCTIME);
		switch(choice){

		case ROCK:
			TextOut(0, 0, "Rock    ", DRAW_OPT_NORMAL);
			while(choice == ROCK){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return ROCK;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice=SPOCK;}

			}
			break;

		case PAPER:
			TextOut(0, 0, "Paper   ", DRAW_OPT_NORMAL);
			while(choice == PAPER){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return PAPER;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case SCISSORS:
			TextOut(0, 0, "Scissors", DRAW_OPT_NORMAL);
			while(choice == SCISSORS){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return SCISSORS;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case LIZARD:
			TextOut(0, 0, "Lizard  ", DRAW_OPT_NORMAL);
			while(choice == LIZARD){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return LIZARD;}
				else if(ButtonPressed(BTNRIGHT, true)){choice++;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		case SPOCK:
			TextOut(0, 0, "Spock   ", DRAW_OPT_NORMAL);
			while(choice == SPOCK){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){return SPOCK;}
				else if(ButtonPressed(BTNRIGHT, true)){choice=ROCK;}
				else if(ButtonPressed(BTNLEFT, true)){choice--;}
			}
			break;

		}
	}
}

//Esito Carta, Forbici, Sasso, Lizard, Spock
bool RockPaperScissors(int robotchoice, int playerchoice, int &robotwin){
	switch(robotchoice){
	case ROCK:
		switch(playerchoice){
		case ROCK:
			robotwin = 3;
			break;

		case PAPER:
			robotwin = 2;
			break;

		case SCISSORS:
			robotwin = 1;
			break;

		case LIZARD:
			robotwin = 1;
			break;

		case SPOCK:
			robotwin = 2;
			break;
		}
		break;

	case PAPER:
		switch(playerchoice){
		case ROCK:
			robotwin = 1;
			break;

		case PAPER:
			robotwin = 3;
			break;

		case SCISSORS:
			robotwin = 2;
			break;

		case LIZARD:
			robotwin = 2;
			break;

		case SPOCK:
			robotwin = 1;
			break;
		}
		break;

	case SCISSORS:
		switch(playerchoice){
		case ROCK:
			robotwin = 2;
			break;

		case PAPER:
			robotwin = 1;
			break;

		case SCISSORS:
			robotwin = 3;
			break;

		case LIZARD:
			robotwin = 1;
			break;

		case SPOCK:
			robotwin = 2;
			break;
		}
		break;

	case LIZARD:
		switch(playerchoice){
		case ROCK:
			robotwin = 2;
			break;

		case PAPER:
			robotwin = 1;
			break;

		case SCISSORS:
			robotwin = 2;
			break;

		case LIZARD:
			robotwin = 3;
			break;

		case SPOCK:
			robotwin = 1;
			break;
		}
		break;

	case SPOCK:
		switch(playerchoice){
		case ROCK:
			robotwin = 1;
			break;

		case PAPER:
			robotwin = 2;
			break;

		case SCISSORS:
			robotwin = 1;
			break;

		case LIZARD:
			robotwin = 2;
			break;

		case SPOCK:
			robotwin = 3;
			break;
		}
		break;
	}

	return true;
}

int FMenu(){
	int menu = 0;
	int mode;

	ClearScreen();

	//Robodroid
Robo:

	while(menu == 0){
		Wait(SYNCTIME);
		ClearScreen();
		TextOut(TEXTLINE_1, TEXTLINE_1, "Robodroid", DRAW_OPT_NORMAL);

		if(ButtonPressed(BTNEXIT, true)){
			//Shut Down the Robot
			menu = 1;

			//Exit
ShutDownTheRobot:

			ClearScreen();
			TextOut(TEXTLINE_1, TEXTLINE_1, "Exit" );

			while(menu == 1){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}
				else if(ButtonPressed(BTNCENTER, true)){
					SendRemoteNumber(BT_CONN2,MAILBOX7,4);
					Wait(1000);
					SendRemoteBool(BT_CONN,MAILBOX9,true);
					Wait(1000);
					PowerDown();
				}
				else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){

					//Cancel
Cancel:
					menu = 2;
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Cancel" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)||ButtonPressed(BTNEXIT, true)){
							menu = 0;
							goto Robo;
						}
						else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
							menu = 1;
							goto ShutDownTheRobot;
						}
					}
				}
				else if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}
			}
		}
		else if(ButtonPressed(BTNCENTER, true)){
			//Quick Match
			menu = 1;

			//Quick Match
Quick:
			ClearScreen();
			TextOut(TEXTLINE_1, TEXTLINE_1, "Quick Match  " , DRAW_OPT_NORMAL);

			while(menu == 1){
				Wait(SYNCTIME);
				if(ButtonPressed(BTNCENTER, true)){
					//1 Player
					mode = QUICKMATCH;
					menu = 2;

					//Single Player
Player:
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Single Player" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)){
							//Start 1 Player Robodroid
							menu = 4;
							SendRemoteNumber(BT_CONN2,MAILBOX7,QUICKMATCH); //Robodroid/QuickMatch/SinglePlayer


						}

						else if(ButtonPressed(BTNEXIT, true)){
							menu = 1;
							goto Quick;
						}
					}
				}
				else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
					//Surival Mode
					menu = 2;

					//Survival Mode
SurvivalMode:
					ClearScreen();
					TextOut(TEXTLINE_1, TEXTLINE_1, "Survival Mode" , DRAW_OPT_NORMAL);

					while(menu == 2){
						Wait(SYNCTIME);
						if(ButtonPressed(BTNCENTER, true)){
							//Start Survival Mode
							mode = SURVIVAL;
							menu = 4;
							SendRemoteNumber(BT_CONN2,MAILBOX7,SURVIVAL); //Robodroid/SurvivalMode

						}
						else if(ButtonPressed(BTNRIGHT, true)||ButtonPressed(BTNLEFT, true)){
							menu = 1;
							goto Quick;
						}
						else if(ButtonPressed(BTNEXIT, true)){
							menu = 0;
							goto Robo;
						}
					}
				}
				else if(ButtonPressed(BTNEXIT, true)){
					menu = 0;
					goto Robo;
				}

			}
		}

	}
	return mode;
}
